import { AfterViewInit, DoCheck, ElementRef, OnChanges, OnDestroy, Renderer2, SimpleChanges } from '@angular/core';
import { AnimationBuilder } from '@angular/animations';
import * as i0 from "@angular/core";
export declare class CollapseDirective implements OnDestroy, AfterViewInit, DoCheck, OnChanges {
    private readonly hostElement;
    private readonly renderer;
    private readonly animationBuilder;
    /**
     * @ignore
     * todo: 'animate' input signal for navbar
     */
    animate: boolean;
    /**
     * Set horizontal collapsing to transition the width instead of height.
     * @type boolean
     * @default false
     */
    readonly horizontal: import("@angular/core").InputSignalWithTransform<boolean, unknown>;
    /**
     * Toggle the visibility of collapsible element.
     * @type boolean
     * @default false
     * todo: 'visible' input signal
     */
    set visible(value: boolean);
    get visible(): boolean;
    private _visible;
    /**
     * Add `navbar` prop for grouping and hiding navbar contents by a parent breakpoint.
     * @type boolean
     * @default false
     */
    readonly navbar: import("@angular/core").InputSignalWithTransform<boolean, unknown>;
    /**
     * @ignore
     */
    readonly duration: import("@angular/core").InputSignal<string>;
    /**
     * @ignore
     */
    readonly transition: import("@angular/core").InputSignal<string>;
    /**
     * Event emitted on visibility change. [docs]
     * @type string
     */
    readonly collapseChange: import("@angular/core").OutputEmitterRef<string>;
    private player;
    private readonly host;
    private scrollWidth;
    private collapsing;
    constructor(hostElement: ElementRef, renderer: Renderer2, animationBuilder: AnimationBuilder);
    readonly hostClasses: import("@angular/core").Signal<Record<string, boolean>>;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngDoCheck(): void;
    toggle(visible?: boolean): void;
    destroyPlayer(): void;
    createPlayer(visible?: boolean): void;
    setMaxSize(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CollapseDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<CollapseDirective, "[cCollapse]", ["cCollapse"], { "animate": { "alias": "animate"; "required": false; }; "horizontal": { "alias": "horizontal"; "required": false; "isSignal": true; }; "visible": { "alias": "visible"; "required": false; }; "navbar": { "alias": "navbar"; "required": false; "isSignal": true; }; "duration": { "alias": "duration"; "required": false; "isSignal": true; }; "transition": { "alias": "transition"; "required": false; "isSignal": true; }; }, { "collapseChange": "collapseChange"; }, never, never, true, never>;
    static ngAcceptInputType_animate: unknown;
    static ngAcceptInputType_visible: unknown;
}
